#ifndef BAY_H
#define BAY_H

#include "Motor.h"
#include "Point.h"
#include "MaterialCalibration.h"

namespace PROJECT_NAMESPACE
{
     class Bay
     {          
          public:
               string name; //name of the bay
               Motor* motor; //motor assigned to bay
               Point location; //Physical location of bay
               MaterialCalibration* materialCalibration; //material and parameters assigned to bay

			   ///Blank Constructor for the Bay
               Bay(void); 

			   ///Creates a bay with the given name, location, and motor to the bay
               Bay(string,Point,Motor*);
     };
}

#endif //ndef BAY_H