#ifndef MATERIALCALIBRATION_H
#define MATERIALCALIBRATION_H

#include "util/Util.h"

namespace PROJECT_NAMESPACE
{
     class MaterialCalibration
     {          
          public:
              //CONSTANTS/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
			  //Further details can be found in the FAB file description (http://docs.google.com/Doc?docid=0AWrq-7N4RL-KYWpqMnYzZm5iNHh3XzU1Y3FyMmpzZDI&hl=en)
	          string NAME; //name of the material
	          double PATH_SPEED; //speed that the tool will execute the path at
			  double PATH_WIDTH; //the width of the path
			  double DEPOSITION_RATE; //rate at which to release the material
			  double PUSHOUT; //amount of material to start pushing out before executing a pthat
			  double SUCKBACK; //amount of material to start sucking back before ending a path
			  double SUCKBACK_DELAY; //delay in starting suckback ruitine
			  double CLEARANCE; //distance from tip to printing surface
			  double PITCH; //the putch of the tip
              int PAUSE_PATHS; //how many paths to execute before pausing the tool (desined to help with refills)
              //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

		     int pathsExecuted; //Number of paths that have been executed
                    
		     //Creates a material calibration named name.
              MaterialCalibration(const string& name, const double& pathSpeed, const double& pathWidth, const double& depositionRate, const double& pushout, const double& suckback, const double& suckbackDelay, const double& clearance, int pausePaths, const double& pitch);
     		     
		     //Blank constructor
		     MaterialCalibration();      
     };
}
     
#endif //ndef MATERIALCALIBRATION_H
