#ifndef PATH_H
#define PATH_H

#include "util/Util.h"
#include "Point.h"
#include "Tool.h"

namespace PROJECT_NAMESPACE
{
	//A Path object is a sequence of points that is executed by a tool.
	class Path
	{          
	public:
		double length; //the length of the path
		MaterialCalibration* materialCalibration; //material used from printing the path
		vector<Point> points; //points in the path

		//Creates a path with the given material along the given points
		Path(MaterialCalibration*, vector<Point>&);

	private:
		//Returns the length of the path made up of the given points
		static double calcLength(const vector<Point>& points);
	};
}

#endif //ndef PATH_H
